:- include('extractor.pl').

% query(name, [param], Result)

query(start, X) :-
    satisfy(fact(start, _, start, _, _), X).

query(project, X) :-
    satisfy(fact(project, _, jproject, _, _), X).

query(class, X) :-
    satisfy(fact(class, _, jclass, _, _), X).

query(fullyQualifiedName, X) :-
    satisfy(fact(fullyQualifiedName, _, string, _, _), X).
      
query(hasMethod, X) :-
    satisfy(fact(hasMethod, _, jmethod, _, _), X).

query(calls, Name, X) :-
    satisfy(fact(calls, _, jmethodcall, Node, _), X),
    fact(methodObject, Node, string, _, this),
    fact(methodName, Node, string, _, Name).

query(implements, Name, X) :-
    satisfy(fact(implements, _, string, _, Name), X).

query(assignableTo, BaseClass, X) :-
    satisfy(fact(assignableTo, _, string, _, BaseClass), X).

query(methodName, Name, X) :-
    satisfy(fact(methodName, _, string, _, Name), X).

query(methodRetType, RetType, X) :-
    satisfy(fact(methodRetType, _, jtype, _, RetType), X).

query(methodObject, Object, X) :-
    satisfy(fact(methodObject, _, string, _, Object), X).

query(argVal, N, X) :-
    satisfy(fact(argVal, _, _, _, (N, _)), X).